Description

Hi

we are using Redmine with a like 3 different LDAP auth sources, and sometimes if one of the goes down, almsot every process
involved with Redmine slow down terribly.

It seems that when some use riry to log in, Redmien try to contact the server that's not responding, waiting indefinitely for the action
to be completed, making everything slow. There should be a (configurable perhaps?) timeout (I think that a sane default could be 30
seconds), and then the LDAP source should be considered dead (at least for that request).

i'm using Redmine 1.1.2.stable.5317

Associated revisions

Revision 9931 - 2012-07-07 11:36 - Jean-Philippe Lang
Adds a configurable timeout for LDAP authentication (#8978).

Revision 9932 - 2012-07-07 11:37 - Jean-Philippe Lang
Fills locales (#8978).

History

#1 - 2011-08-04 00:04 - Terence Mill
you can try if redmine_ldap_sync can handle this better.

#2 - 2012-06-29 03:21 - Brett Patterson

| can confirm this happens in 2.0.3 as well. We used to use LDAP to authenticate and when we took our LDAP system offline | forgot some users
were still configured and instead of seeing a message about unable to log in or LDAP authentication server unreachable, it gave a 500 error.

#3 - 2012-06-29 04:32 - Brett Patterson
- File Idap_timeout-v2.0.3.patch added

Here's a quick patch | made against 2.0.3. This will catch a timeout error after 30 seconds and redirect the user with a proper error message. This is
english only and really is a proof-of-concept. Ideally the timeout would default to 30 seconds but could be modified via the administration settings (or
per-LDAP definition).

Perhaps the Timeout class is not the best solution in this case; however, from my testing it works.

#4 - 2012-06-29 10:36 - Etienne Massip

- Target version set to Candidate for next major release

Brett Patterson wrote:

Perhaps the Timeout class is not the best solution in this case; however, from my testing it works.

Actually seems to be a great idea.

#5 - 2012-06-30 04:10 - Brett Patterson
- File Idap_timeout_v2-redmine2.0.3.patch added
https://github.com/thorin/redmine_ldap_sync

Worked on it some more and now the timeout is configurable on a per-connection basis in the LDAP settings. If no timeout value is set, the default of

20 is set.

In order to use this, the following SQL must be run:

ALTER TABLE "auth_sources® ADD COLUMN " timeout ™ int(11) DEFAULT NULL AFTER "port’;

#6 - 2012-07-06 21:35 - Jean-Philippe Lang

- Target version changed from Candidate for next major release to 2.1.0

Is there a good reason to set the timeout for each LDAP instead of a global setting?

#7 - 2012-07-06 23:34 - Brett Patterson

A good reason not really. It may be preferable to have "local" LDAP connections have a faster timeout than remote ones, so there may be some

instances where adding an extra second here and there is preferable.

#8 - 2012-07-07 11:36 - Jean-Philippe Lang
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Feature added in r9931 with slight changes and test. Thanks.

#9 - 2012-07-07 11:56 - Davide Ferrari

Thanks a lot!

Files

ldap_timeout-v2.0.3.patch 2.46 KB 2012-06-29 Brett Patterson

ldap_timeout_v2-redmine2.0.3.patch 3.91 KB 2012-06-30 Brett Patterson
